/* config-schema.c generated by valac 0.11.5, the Vala compiler
 * generated from config-schema.vala, do not modify */

/*
 * Desktop Agnostic Library: Configuration Schema.
 *
 * Copyright (C) 2008, 2009 Mark Lee <libdesktop-agnostic@lazymalevolence.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 *
 * Author : Mark Lee <libdesktop-agnostic@lazymalevolence.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <hashtable-gtype-key.c>
#include <float.h>
#include <math.h>
#include <glib/gstdio.h>
#include <libdesktop-agnostic/desktop-agnostic.h>
#include <libdesktop-agnostic/vfs.h>


#define DESKTOP_AGNOSTIC_CONFIG_TYPE_SCHEMA (desktop_agnostic_config_schema_get_type ())
#define DESKTOP_AGNOSTIC_CONFIG_SCHEMA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_AGNOSTIC_CONFIG_TYPE_SCHEMA, DesktopAgnosticConfigSchema))
#define DESKTOP_AGNOSTIC_CONFIG_SCHEMA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DESKTOP_AGNOSTIC_CONFIG_TYPE_SCHEMA, DesktopAgnosticConfigSchemaClass))
#define DESKTOP_AGNOSTIC_CONFIG_IS_SCHEMA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_AGNOSTIC_CONFIG_TYPE_SCHEMA))
#define DESKTOP_AGNOSTIC_CONFIG_IS_SCHEMA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DESKTOP_AGNOSTIC_CONFIG_TYPE_SCHEMA))
#define DESKTOP_AGNOSTIC_CONFIG_SCHEMA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DESKTOP_AGNOSTIC_CONFIG_TYPE_SCHEMA, DesktopAgnosticConfigSchemaClass))

typedef struct _DesktopAgnosticConfigSchema DesktopAgnosticConfigSchema;
typedef struct _DesktopAgnosticConfigSchemaClass DesktopAgnosticConfigSchemaClass;
typedef struct _DesktopAgnosticConfigSchemaPrivate DesktopAgnosticConfigSchemaPrivate;

#define DESKTOP_AGNOSTIC_CONFIG_TYPE_SCHEMA_OPTION (desktop_agnostic_config_schema_option_get_type ())
#define DESKTOP_AGNOSTIC_CONFIG_SCHEMA_OPTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_AGNOSTIC_CONFIG_TYPE_SCHEMA_OPTION, DesktopAgnosticConfigSchemaOption))
#define DESKTOP_AGNOSTIC_CONFIG_SCHEMA_OPTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DESKTOP_AGNOSTIC_CONFIG_TYPE_SCHEMA_OPTION, DesktopAgnosticConfigSchemaOptionClass))
#define DESKTOP_AGNOSTIC_CONFIG_IS_SCHEMA_OPTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_AGNOSTIC_CONFIG_TYPE_SCHEMA_OPTION))
#define DESKTOP_AGNOSTIC_CONFIG_IS_SCHEMA_OPTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DESKTOP_AGNOSTIC_CONFIG_TYPE_SCHEMA_OPTION))
#define DESKTOP_AGNOSTIC_CONFIG_SCHEMA_OPTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DESKTOP_AGNOSTIC_CONFIG_TYPE_SCHEMA_OPTION, DesktopAgnosticConfigSchemaOptionClass))

typedef struct _DesktopAgnosticConfigSchemaOption DesktopAgnosticConfigSchemaOption;
typedef struct _DesktopAgnosticConfigSchemaOptionClass DesktopAgnosticConfigSchemaOptionClass;

#define DESKTOP_AGNOSTIC_CONFIG_TYPE_SCHEMA_TYPE (desktop_agnostic_config_schema_type_get_type ())
#define DESKTOP_AGNOSTIC_CONFIG_SCHEMA_TYPE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DESKTOP_AGNOSTIC_CONFIG_TYPE_SCHEMA_TYPE, DesktopAgnosticConfigSchemaType))
#define DESKTOP_AGNOSTIC_CONFIG_SCHEMA_TYPE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DESKTOP_AGNOSTIC_CONFIG_TYPE_SCHEMA_TYPE, DesktopAgnosticConfigSchemaTypeClass))
#define DESKTOP_AGNOSTIC_CONFIG_IS_SCHEMA_TYPE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DESKTOP_AGNOSTIC_CONFIG_TYPE_SCHEMA_TYPE))
#define DESKTOP_AGNOSTIC_CONFIG_IS_SCHEMA_TYPE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DESKTOP_AGNOSTIC_CONFIG_TYPE_SCHEMA_TYPE))
#define DESKTOP_AGNOSTIC_CONFIG_SCHEMA_TYPE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DESKTOP_AGNOSTIC_CONFIG_TYPE_SCHEMA_TYPE, DesktopAgnosticConfigSchemaTypeClass))

typedef struct _DesktopAgnosticConfigSchemaType DesktopAgnosticConfigSchemaType;
typedef struct _DesktopAgnosticConfigSchemaTypeClass DesktopAgnosticConfigSchemaTypeClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define __g_list_free__g_free0_0(var) ((var == NULL) ? NULL : (var = (_g_list_free__g_free0_ (var), NULL)))
#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_key_file_free0(var) ((var == NULL) ? NULL : (var = (g_key_file_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define __g_slist_free__g_free0_0(var) ((var == NULL) ? NULL : (var = (_g_slist_free__g_free0_ (var), NULL)))

/**
   * Configuration schema error types.
   */
typedef enum  {
	DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR_PARSE,
	DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR_INVALID_METADATA_OPTION,
	DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR_INVALID_METADATA_TYPE,
	DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR_INVALID_TYPE,
	DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR_INVALID_LIST_TYPE,
	DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR_TYPE_NAME_EXISTS,
	DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR_TYPE_GTYPE_EXISTS
} DesktopAgnosticConfigSchemaError;
#define DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR desktop_agnostic_config_schema_error_quark ()
struct _DesktopAgnosticConfigSchema {
	GObject parent_instance;
	DesktopAgnosticConfigSchemaPrivate * priv;
};

struct _DesktopAgnosticConfigSchemaClass {
	GObjectClass parent_class;
};

struct _DesktopAgnosticConfigSchemaPrivate {
	gchar* _filename;
	gchar* _app_name;
	GData* options;
	GHashTable* keys;
	GList* valid_metadata_keys;
	GData* metadata_options;
};


static gpointer desktop_agnostic_config_schema_parent_class = NULL;
static GHashTable* desktop_agnostic_config_schema_type_registry;
static GHashTable* desktop_agnostic_config_schema_type_registry = NULL;
static GHashTable* desktop_agnostic_config_schema_name_registry;
static GHashTable* desktop_agnostic_config_schema_name_registry = NULL;
static GHashTable* desktop_agnostic_config_schema_common_metadata_keys;
static GHashTable* desktop_agnostic_config_schema_common_metadata_keys = NULL;

GQuark desktop_agnostic_config_schema_error_quark (void);
GType desktop_agnostic_config_schema_get_type (void) G_GNUC_CONST;
GType desktop_agnostic_config_schema_option_get_type (void) G_GNUC_CONST;
#define DESKTOP_AGNOSTIC_CONFIG_SCHEMA_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DESKTOP_AGNOSTIC_CONFIG_TYPE_SCHEMA, DesktopAgnosticConfigSchemaPrivate))
enum  {
	DESKTOP_AGNOSTIC_CONFIG_SCHEMA_DUMMY_PROPERTY,
	DESKTOP_AGNOSTIC_CONFIG_SCHEMA_FILENAME,
	DESKTOP_AGNOSTIC_CONFIG_SCHEMA_APP_NAME
};
GType desktop_agnostic_config_schema_type_get_type (void) G_GNUC_CONST;
static void _g_object_unref0_ (gpointer var);
static void _g_free0_ (gpointer var);
static void _vala_GValue_free (GValue* self);
static void __vala_GValue_free0_ (gpointer var);
static void _g_list_free__g_free0_ (GList* self);
DesktopAgnosticConfigSchema* desktop_agnostic_config_schema_new (const gchar* filename, GError** error);
DesktopAgnosticConfigSchema* desktop_agnostic_config_schema_construct (GType object_type, const gchar* filename, GError** error);
static void __g_list_free__g_free0_0_ (gpointer var);
static GValue* _g_value_dup (GValue* self);
GHashTable* desktop_agnostic_config_backend_get_backend_metadata_keys (void);
static void desktop_agnostic_config_schema_parse (DesktopAgnosticConfigSchema* self, GError** error);
gboolean desktop_agnostic_config_schema_exists (DesktopAgnosticConfigSchema* self, const gchar* group, const gchar* key);
DesktopAgnosticConfigSchemaOption* desktop_agnostic_config_schema_option_new (GKeyFile** schema, const gchar* group, const gchar* key, GError** error);
DesktopAgnosticConfigSchemaOption* desktop_agnostic_config_schema_option_construct (GType object_type, GKeyFile** schema, const gchar* group, const gchar* key, GError** error);
#define DESKTOP_AGNOSTIC_CONFIG_GROUP_DEFAULT "DEFAULT"
GList* desktop_agnostic_config_schema_get_groups (DesktopAgnosticConfigSchema* self);
GList* desktop_agnostic_config_schema_get_keys (DesktopAgnosticConfigSchema* self, const gchar* group);
DesktopAgnosticConfigSchemaOption* desktop_agnostic_config_schema_get_option (DesktopAgnosticConfigSchema* self, const gchar* group, const gchar* key);
GValue* desktop_agnostic_config_schema_get_metadata_option (DesktopAgnosticConfigSchema* self, const gchar* name, GError** error);
void desktop_agnostic_config_schema_register_type (DesktopAgnosticConfigSchemaType* st, GError** error);
GType desktop_agnostic_config_schema_type_get_schema_type (DesktopAgnosticConfigSchemaType* self);
gchar* desktop_agnostic_config_schema_type_get_name (DesktopAgnosticConfigSchemaType* self);
DesktopAgnosticConfigSchemaType* desktop_agnostic_config_schema_find_type (GType type);
DesktopAgnosticConfigSchemaType* desktop_agnostic_config_schema_find_type_by_name (const gchar* name);
static void desktop_agnostic_config_schema_set_filename (DesktopAgnosticConfigSchema* self, const gchar* value);
static void desktop_agnostic_config_schema_set_app_name (DesktopAgnosticConfigSchema* self, const gchar* value);
const gchar* desktop_agnostic_config_schema_get_app_name (DesktopAgnosticConfigSchema* self);
GType desktop_agnostic_config_get_type (GError** error);
static void _g_slist_free__g_free0_ (GSList* self);
static void desktop_agnostic_config_schema_finalize (GObject* obj);
static void _vala_desktop_agnostic_config_schema_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_desktop_agnostic_config_schema_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


GQuark desktop_agnostic_config_schema_error_quark (void) {
	return g_quark_from_static_string ("desktop_agnostic_config_schema_error-quark");
}


static void _g_object_unref0_ (gpointer var) {
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}


static void _g_free0_ (gpointer var) {
	var = (g_free (var), NULL);
}


static void _vala_GValue_free (GValue* self) {
	g_value_unset (self);
	g_free (self);
}


static void __vala_GValue_free0_ (gpointer var) {
	(var == NULL) ? NULL : (var = (_vala_GValue_free (var), NULL));
}


static void _g_list_free__g_free0_ (GList* self) {
	g_list_foreach (self, (GFunc) _g_free0_, NULL);
	g_list_free (self);
}


/**
     * Creates a new Schema object.
     * @param filename the name of the schema file to parse
     */
static void __g_list_free__g_free0_0_ (gpointer var) {
	(var == NULL) ? NULL : (var = (_g_list_free__g_free0_ (var), NULL));
}


static GValue* _g_value_dup (GValue* self) {
	return g_boxed_copy (G_TYPE_VALUE, self);
}


static gpointer __g_value_dup0 (gpointer self) {
	return self ? _g_value_dup (self) : NULL;
}


DesktopAgnosticConfigSchema* desktop_agnostic_config_schema_construct (GType object_type, const gchar* filename, GError** error) {
	DesktopAgnosticConfigSchema * self = NULL;
	GHashTable* backend_metadata_keys = NULL;
	GData* _tmp0_ = {0};
	GData* _tmp1_ = {0};
	GHashTable* _tmp2_ = NULL;
	GHashTable* _tmp3_;
	GList* _tmp4_;
	GData* _tmp5_ = {0};
	GData* _tmp6_ = {0};
	GList* _tmp7_ = NULL;
	GHashTable* _tmp11_ = NULL;
	GList* _tmp12_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (filename != NULL, NULL);
	self = (DesktopAgnosticConfigSchema*) g_object_new (object_type, "filename", filename, NULL);
	g_datalist_init (&_tmp0_);
	_tmp1_ = _tmp0_;
	self->priv->options = _tmp1_;
	_tmp2_ = g_hash_table_new_full (g_str_hash, g_str_equal, _g_free0_, __g_list_free__g_free0_0_);
	_tmp3_ = _tmp2_;
	_g_hash_table_unref0 (self->priv->keys);
	self->priv->keys = _tmp3_;
	_tmp4_ = NULL;
	__g_list_free__g_free0_0 (self->priv->valid_metadata_keys);
	self->priv->valid_metadata_keys = _tmp4_;
	g_datalist_init (&_tmp5_);
	_tmp6_ = _tmp5_;
	self->priv->metadata_options = _tmp6_;
	_tmp7_ = g_hash_table_get_keys (desktop_agnostic_config_schema_common_metadata_keys);
	{
		GList* key_collection;
		GList* key_it;
		key_collection = _tmp7_;
		for (key_it = key_collection; key_it != NULL; key_it = key_it->next) {
			const gchar* key;
			key = (const gchar*) key_it->data;
			{
				gchar* _tmp8_;
				gconstpointer _tmp9_ = NULL;
				GValue* _tmp10_;
				_tmp8_ = g_strdup (key);
				self->priv->valid_metadata_keys = g_list_append (self->priv->valid_metadata_keys, _tmp8_);
				_tmp9_ = g_hash_table_lookup (desktop_agnostic_config_schema_common_metadata_keys, key);
				_tmp10_ = __g_value_dup0 ((GValue*) _tmp9_);
				g_datalist_set_data (&self->priv->metadata_options, key, _tmp10_);
			}
		}
		_g_list_free0 (key_collection);
	}
	_tmp11_ = desktop_agnostic_config_backend_get_backend_metadata_keys ();
	backend_metadata_keys = _tmp11_;
	_tmp12_ = g_hash_table_get_keys (backend_metadata_keys);
	{
		GList* key_collection;
		GList* key_it;
		key_collection = _tmp12_;
		for (key_it = key_collection; key_it != NULL; key_it = key_it->next) {
			const gchar* key;
			key = (const gchar*) key_it->data;
			{
				gchar* _tmp13_;
				gconstpointer _tmp14_ = NULL;
				GValue* _tmp15_;
				_tmp13_ = g_strdup (key);
				self->priv->valid_metadata_keys = g_list_append (self->priv->valid_metadata_keys, _tmp13_);
				_tmp14_ = g_hash_table_lookup (backend_metadata_keys, key);
				_tmp15_ = __g_value_dup0 ((GValue*) _tmp14_);
				g_datalist_set_data (&self->priv->metadata_options, key, _tmp15_);
			}
		}
		_g_list_free0 (key_collection);
	}
	desktop_agnostic_config_schema_parse (self, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (self);
		return NULL;
	}
	return self;
}


DesktopAgnosticConfigSchema* desktop_agnostic_config_schema_new (const gchar* filename, GError** error) {
	return desktop_agnostic_config_schema_construct (DESKTOP_AGNOSTIC_CONFIG_TYPE_SCHEMA, filename, error);
}


/**
     * Parses the schema file for configuration options and metadata.
     */
static gboolean string_contains (const gchar* self, const gchar* needle) {
	gboolean result = FALSE;
	gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}


static glong string_pointer_to_offset (const gchar* self, const gchar* pos) {
	glong result = 0L;
	g_return_val_if_fail (self != NULL, 0L);
	g_return_val_if_fail (pos != NULL, 0L);
	result = (glong) (((gchar*) pos) - ((gchar*) self));
	return result;
}


static gchar* string_substring (const gchar* self, glong offset, glong len) {
	gchar* result = NULL;
	gint _tmp0_;
	glong string_length;
	gchar* _tmp1_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = strlen (self);
	string_length = (glong) _tmp0_;
	if (offset < 0) {
		offset = string_length + offset;
		g_return_val_if_fail (offset >= 0, NULL);
	} else {
		g_return_val_if_fail (offset <= string_length, NULL);
	}
	if (len < 0) {
		len = string_length - offset;
	}
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
	_tmp1_ = g_strndup (((gchar*) self) + offset, (gsize) len);
	result = _tmp1_;
	return result;
}


static const gchar* string_offset (const gchar* self, glong offset) {
	const gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = (const gchar*) (((gchar*) self) + offset);
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void desktop_agnostic_config_schema_parse (DesktopAgnosticConfigSchema* self, GError** error) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	if (self->priv->_filename == NULL) {
		GError* _tmp0_ = NULL;
		_tmp0_ = g_error_new_literal (DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR, DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR_PARSE, "A (valid) schema file was not given.");
		_inner_error_ = _tmp0_;
		g_propagate_error (error, _inner_error_);
		return;
	} else {
		GKeyFile* _tmp1_ = NULL;
		GKeyFile* data;
		gsize _tmp2_;
		gchar** _tmp3_ = NULL;
		_tmp1_ = g_key_file_new ();
		data = _tmp1_;
		g_key_file_load_from_file (data, self->priv->_filename, G_KEY_FILE_KEEP_TRANSLATIONS, &_inner_error_);
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_g_key_file_free0 (data);
			return;
		}
		_tmp3_ = g_key_file_get_groups (data, &_tmp2_);
		{
			gchar** group_collection;
			int group_collection_length1;
			int group_it;
			group_collection = _tmp3_;
			group_collection_length1 = _tmp2_;
			for (group_it = 0; group_it < _tmp2_; group_it = group_it + 1) {
				const gchar* group;
				group = group_collection[group_it];
				{
					gboolean _tmp4_;
					_tmp4_ = string_contains (group, "/");
					if (_tmp4_) {
						gint _tmp5_;
						const gchar* _tmp6_ = NULL;
						const gchar* last_slash;
						glong _tmp7_;
						glong offset;
						gchar* _tmp8_ = NULL;
						gchar* option_group;
						const gchar* _tmp9_ = NULL;
						const gchar* option_key;
						gconstpointer _tmp10_ = NULL;
						GList* list;
						DesktopAgnosticConfigSchemaOption* _tmp17_ = NULL;
						DesktopAgnosticConfigSchemaOption* option;
						DesktopAgnosticConfigSchemaOption* _tmp18_;
						_tmp5_ = strlen (group);
						_tmp6_ = g_utf8_strrchr (group, (gssize) _tmp5_, (gunichar) '/');
						last_slash = _tmp6_;
						_tmp7_ = string_pointer_to_offset (group, last_slash);
						offset = _tmp7_;
						_tmp8_ = string_substring (group, (glong) 0, offset);
						option_group = _tmp8_;
						_tmp9_ = string_offset (group, offset + 1);
						option_key = _tmp9_;
						_tmp10_ = g_hash_table_lookup (self->priv->keys, option_group);
						list = (GList*) _tmp10_;
						if (list == NULL) {
							GList* key_list;
							gchar* _tmp11_;
							gchar* _tmp12_;
							GList* _tmp13_;
							key_list = NULL;
							_tmp11_ = g_strdup (option_key);
							key_list = g_list_append (key_list, _tmp11_);
							_tmp12_ = g_strdup (option_group);
							_tmp13_ = key_list;
							key_list = NULL;
							g_hash_table_insert (self->priv->keys, _tmp12_, _tmp13_);
							__g_list_free__g_free0_0 (key_list);
						} else {
							gboolean _tmp14_;
							_tmp14_ = desktop_agnostic_config_schema_exists (self, option_group, option_key);
							if (!_tmp14_) {
								gchar* _tmp15_;
								_tmp15_ = g_strdup (option_key);
								list = g_list_append (list, _tmp15_);
							} else {
								GError* _tmp16_ = NULL;
								_tmp16_ = g_error_new (DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR, DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR_PARSE, "Duplicate key found in '%s': %s", option_group, option_key);
								_inner_error_ = _tmp16_;
								g_propagate_error (error, _inner_error_);
								_g_free0 (option_group);
								group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
								_g_key_file_free0 (data);
								return;
							}
						}
						_tmp17_ = desktop_agnostic_config_schema_option_new (&data, option_group, option_key, &_inner_error_);
						option = _tmp17_;
						if (_inner_error_ != NULL) {
							g_propagate_error (error, _inner_error_);
							_g_free0 (option_group);
							group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
							_g_key_file_free0 (data);
							return;
						}
						_tmp18_ = _g_object_ref0 (option);
						g_datalist_set_data (&self->priv->options, group, _tmp18_);
						_g_object_unref0 (option);
						_g_free0 (option_group);
					} else {
						if (g_strcmp0 (group, DESKTOP_AGNOSTIC_CONFIG_GROUP_DEFAULT) == 0) {
							gsize _tmp19_;
							gchar** _tmp20_ = NULL;
							gchar** _tmp21_;
							gint _tmp21__length1;
							gint __tmp21__size_;
							_tmp20_ = g_key_file_get_keys (data, group, &_tmp19_, &_inner_error_);
							_tmp21_ = _tmp20_;
							_tmp21__length1 = _tmp19_;
							__tmp21__size_ = _tmp19_;
							if (_inner_error_ != NULL) {
								g_propagate_error (error, _inner_error_);
								group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
								_g_key_file_free0 (data);
								return;
							}
							{
								gchar** key_collection;
								int key_collection_length1;
								int key_it;
								key_collection = _tmp21_;
								key_collection_length1 = _tmp21__length1;
								for (key_it = 0; key_it < _tmp21__length1; key_it = key_it + 1) {
									const gchar* key;
									key = key_collection[key_it];
									{
										GList* _tmp22_ = NULL;
										_tmp22_ = g_list_find_custom (self->priv->valid_metadata_keys, key, (GCompareFunc) g_strcmp0);
										if (_tmp22_ == NULL) {
											GError* _tmp23_ = NULL;
											_tmp23_ = g_error_new (DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR, DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR_INVALID_METADATA_OPTION, "The option '%s' is not a registered metadata option.", key);
											_inner_error_ = _tmp23_;
											g_propagate_error (error, _inner_error_);
											key_collection = (_vala_array_free (key_collection, key_collection_length1, (GDestroyNotify) g_free), NULL);
											group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
											_g_key_file_free0 (data);
											return;
										} else {
											GValue cur_val = {0};
											GValue new_val = {0};
											GType cur_val_type = 0UL;
											gconstpointer _tmp24_ = NULL;
											GValue _tmp25_;
											GValue _tmp26_ = {0};
											GValue _tmp27_;
											GType _tmp28_;
											GValue _tmp29_ = {0};
											GValue _tmp30_ = {0};
											GValue _tmp31_;
											GValue* _tmp42_;
											_tmp24_ = g_datalist_get_data (&self->priv->metadata_options, key);
											_tmp25_ = G_IS_VALUE ((GValue*) _tmp24_) ? (g_value_init (&_tmp26_, G_VALUE_TYPE ((GValue*) _tmp24_)), g_value_copy ((GValue*) _tmp24_, &_tmp26_), _tmp26_) : (*((GValue*) _tmp24_));
											_tmp27_ = _tmp25_;
											G_IS_VALUE (&cur_val) ? (g_value_unset (&cur_val), NULL) : NULL;
											cur_val = _tmp27_;
											_tmp28_ = G_VALUE_TYPE (&cur_val);
											cur_val_type = _tmp28_;
											g_value_init (&_tmp29_, cur_val_type);
											_tmp30_ = _tmp29_;
											_tmp31_ = _tmp30_;
											G_IS_VALUE (&new_val) ? (g_value_unset (&new_val), NULL) : NULL;
											new_val = _tmp31_;
											if (cur_val_type == G_TYPE_BOOLEAN) {
												gboolean _tmp32_;
												gboolean _tmp33_;
												_tmp32_ = g_key_file_get_boolean (data, group, key, &_inner_error_);
												_tmp33_ = _tmp32_;
												if (_inner_error_ != NULL) {
													g_propagate_error (error, _inner_error_);
													G_IS_VALUE (&new_val) ? (g_value_unset (&new_val), NULL) : NULL;
													G_IS_VALUE (&cur_val) ? (g_value_unset (&cur_val), NULL) : NULL;
													key_collection = (_vala_array_free (key_collection, key_collection_length1, (GDestroyNotify) g_free), NULL);
													group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
													_g_key_file_free0 (data);
													return;
												}
												g_value_set_boolean (&new_val, _tmp33_);
											} else {
												if (cur_val_type == G_TYPE_INT) {
													gint _tmp34_;
													gint _tmp35_;
													_tmp34_ = g_key_file_get_integer (data, group, key, &_inner_error_);
													_tmp35_ = _tmp34_;
													if (_inner_error_ != NULL) {
														g_propagate_error (error, _inner_error_);
														G_IS_VALUE (&new_val) ? (g_value_unset (&new_val), NULL) : NULL;
														G_IS_VALUE (&cur_val) ? (g_value_unset (&cur_val), NULL) : NULL;
														key_collection = (_vala_array_free (key_collection, key_collection_length1, (GDestroyNotify) g_free), NULL);
														group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
														_g_key_file_free0 (data);
														return;
													}
													g_value_set_int (&new_val, _tmp35_);
												} else {
													if (cur_val_type == G_TYPE_FLOAT) {
														gdouble _tmp36_;
														gdouble _tmp37_;
														_tmp36_ = g_key_file_get_double (data, group, key, &_inner_error_);
														_tmp37_ = _tmp36_;
														if (_inner_error_ != NULL) {
															g_propagate_error (error, _inner_error_);
															G_IS_VALUE (&new_val) ? (g_value_unset (&new_val), NULL) : NULL;
															G_IS_VALUE (&cur_val) ? (g_value_unset (&cur_val), NULL) : NULL;
															key_collection = (_vala_array_free (key_collection, key_collection_length1, (GDestroyNotify) g_free), NULL);
															group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
															_g_key_file_free0 (data);
															return;
														}
														g_value_set_float (&new_val, (gfloat) _tmp37_);
													} else {
														if (cur_val_type == G_TYPE_STRING) {
															gchar* _tmp38_ = NULL;
															gchar* _tmp39_;
															gchar* _tmp40_;
															_tmp38_ = g_key_file_get_string (data, group, key, &_inner_error_);
															_tmp39_ = _tmp38_;
															if (_inner_error_ != NULL) {
																g_propagate_error (error, _inner_error_);
																G_IS_VALUE (&new_val) ? (g_value_unset (&new_val), NULL) : NULL;
																G_IS_VALUE (&cur_val) ? (g_value_unset (&cur_val), NULL) : NULL;
																key_collection = (_vala_array_free (key_collection, key_collection_length1, (GDestroyNotify) g_free), NULL);
																group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
																_g_key_file_free0 (data);
																return;
															}
															_tmp40_ = _tmp39_;
															g_value_set_string (&new_val, _tmp40_);
															_g_free0 (_tmp40_);
														} else {
															GError* _tmp41_ = NULL;
															_tmp41_ = g_error_new_literal (DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR, DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR_INVALID_METADATA_TYPE, "The metadata option type can only be a simple type.");
															_inner_error_ = _tmp41_;
															g_propagate_error (error, _inner_error_);
															G_IS_VALUE (&new_val) ? (g_value_unset (&new_val), NULL) : NULL;
															G_IS_VALUE (&cur_val) ? (g_value_unset (&cur_val), NULL) : NULL;
															key_collection = (_vala_array_free (key_collection, key_collection_length1, (GDestroyNotify) g_free), NULL);
															group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
															_g_key_file_free0 (data);
															return;
														}
													}
												}
											}
											_tmp42_ = __g_value_dup0 (&new_val);
											g_datalist_set_data (&self->priv->metadata_options, key, _tmp42_);
											G_IS_VALUE (&new_val) ? (g_value_unset (&new_val), NULL) : NULL;
											G_IS_VALUE (&cur_val) ? (g_value_unset (&cur_val), NULL) : NULL;
										}
									}
								}
								key_collection = (_vala_array_free (key_collection, key_collection_length1, (GDestroyNotify) g_free), NULL);
							}
						} else {
							GError* _tmp43_ = NULL;
							_tmp43_ = g_error_new (DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR, DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR_PARSE, "Invalid section in schema ('%s'), there is no group name: %s", self->priv->_filename, group);
							_inner_error_ = _tmp43_;
							g_propagate_error (error, _inner_error_);
							group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
							_g_key_file_free0 (data);
							return;
						}
					}
				}
			}
			group_collection = (_vala_array_free (group_collection, group_collection_length1, (GDestroyNotify) g_free), NULL);
		}
		_g_key_file_free0 (data);
	}
}


/**
     * Retrieves the configuration groups in the schema.
     * @return a list of zero or more groups
     */
GList* desktop_agnostic_config_schema_get_groups (DesktopAgnosticConfigSchema* self) {
	GList* result = NULL;
	GList* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_hash_table_get_keys (self->priv->keys);
	result = _tmp0_;
	return result;
}


/**
     * Retrieves the configuration keys for a specified group in the schema.
     * @param group the group name to search for keys associated with it
     * @return a list of zero or more keys
     */
GList* desktop_agnostic_config_schema_get_keys (DesktopAgnosticConfigSchema* self, const gchar* group) {
	GList* result = NULL;
	gconstpointer _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (group != NULL, NULL);
	_tmp0_ = g_hash_table_lookup (self->priv->keys, group);
	result = (GList*) _tmp0_;
	return result;
}


/**
     * Determines if a specified group/key exists in the schema.
     * @param group the group that the key is associated with
     * @param key the configuration key to determine if it exists
     * @return whether the group/key exists
     */
gboolean desktop_agnostic_config_schema_exists (DesktopAgnosticConfigSchema* self, const gchar* group, const gchar* key) {
	gboolean result = FALSE;
	gconstpointer _tmp0_ = NULL;
	GList* group_keys;
	gboolean _tmp1_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (group != NULL, FALSE);
	g_return_val_if_fail (key != NULL, FALSE);
	_tmp0_ = g_hash_table_lookup (self->priv->keys, group);
	group_keys = (GList*) _tmp0_;
	if (group_keys != NULL) {
		GList* _tmp2_ = NULL;
		_tmp2_ = g_list_find_custom (group_keys, key, (GCompareFunc) g_strcmp0);
		_tmp1_ = _tmp2_ != NULL;
	} else {
		_tmp1_ = FALSE;
	}
	result = _tmp1_;
	return result;
}


/**
     * Retrieves the metadata associated with a specific group/key.
     * @param group the group that the key is associated with
     * @param key the configuration key to retrieve metadata from
     * @return an object which contains the option metadata
     */
DesktopAgnosticConfigSchemaOption* desktop_agnostic_config_schema_get_option (DesktopAgnosticConfigSchema* self, const gchar* group, const gchar* key) {
	DesktopAgnosticConfigSchemaOption* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* full_key;
	gconstpointer _tmp2_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (group != NULL, NULL);
	g_return_val_if_fail (key != NULL, NULL);
	_tmp0_ = g_strconcat (group, "/", NULL);
	full_key = (_tmp1_ = g_strconcat (_tmp0_, key, NULL), _g_free0 (_tmp0_), _tmp1_);
	_tmp2_ = g_datalist_get_data (&self->priv->options, full_key);
	result = (DesktopAgnosticConfigSchemaOption*) _tmp2_;
	_g_free0 (full_key);
	return result;
}


/**
     * Retrieves the value of the specified metadata option.
     * @throws SchemaError if the option named specified is not registered
     */
GValue* desktop_agnostic_config_schema_get_metadata_option (DesktopAgnosticConfigSchema* self, const gchar* name, GError** error) {
	GValue* result = NULL;
	GList* _tmp0_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (name != NULL, NULL);
	_tmp0_ = g_list_find_custom (self->priv->valid_metadata_keys, name, (GCompareFunc) g_strcmp0);
	if (_tmp0_ == NULL) {
		GError* _tmp1_ = NULL;
		_tmp1_ = g_error_new (DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR, DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR_INVALID_METADATA_OPTION, "The option '%s' is not a registered metadata option.", name);
		_inner_error_ = _tmp1_;
		if (_inner_error_->domain == DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	} else {
		gconstpointer _tmp2_ = NULL;
		GValue* _tmp3_;
		_tmp2_ = g_datalist_get_data (&self->priv->metadata_options, name);
		_tmp3_ = __g_value_dup0 ((GValue*) _tmp2_);
		result = _tmp3_;
		return result;
	}
}


/**
     * Registers a configuration schema type with the class. This is usually
     * not called manually - the class loads all of the configuration schema
     * type modules that it can find when the class is first instantiated.
     */
void desktop_agnostic_config_schema_register_type (DesktopAgnosticConfigSchemaType* st, GError** error) {
	GType _tmp0_;
	gconstpointer _tmp1_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (st != NULL);
	_tmp0_ = desktop_agnostic_config_schema_type_get_schema_type (st);
	_tmp1_ = g_hash_table_lookup (desktop_agnostic_config_schema_type_registry, GINT_TO_POINTER (_tmp0_));
	if (((DesktopAgnosticConfigSchemaType*) _tmp1_) != NULL) {
		GError* _tmp2_ = NULL;
		_tmp2_ = g_error_new_literal (DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR, DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR_TYPE_GTYPE_EXISTS, "The GType associated with the SchemaType is already registered.");
		_inner_error_ = _tmp2_;
		if (_inner_error_->domain == DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	} else {
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_;
		gconstpointer _tmp5_ = NULL;
		gboolean _tmp6_;
		_tmp3_ = desktop_agnostic_config_schema_type_get_name (st);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_hash_table_lookup (desktop_agnostic_config_schema_name_registry, _tmp4_);
		if ((_tmp6_ = ((DesktopAgnosticConfigSchemaType*) _tmp5_) != NULL, _g_free0 (_tmp4_), _tmp6_)) {
			GError* _tmp7_ = NULL;
			_tmp7_ = g_error_new_literal (DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR, DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR_TYPE_NAME_EXISTS, "The name associated with the SchemaType is already registered.");
			_inner_error_ = _tmp7_;
			if (_inner_error_->domain == DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR) {
				g_propagate_error (error, _inner_error_);
				return;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		} else {
			GType _tmp8_;
			DesktopAgnosticConfigSchemaType* _tmp9_;
			gchar* _tmp10_ = NULL;
			DesktopAgnosticConfigSchemaType* _tmp11_;
			_tmp8_ = desktop_agnostic_config_schema_type_get_schema_type (st);
			_tmp9_ = _g_object_ref0 (st);
			g_hash_table_insert (desktop_agnostic_config_schema_type_registry, GINT_TO_POINTER (_tmp8_), _tmp9_);
			_tmp10_ = desktop_agnostic_config_schema_type_get_name (st);
			_tmp11_ = _g_object_ref0 (st);
			g_hash_table_insert (desktop_agnostic_config_schema_name_registry, _tmp10_, _tmp11_);
		}
	}
}


/**
     * Looks for a registered SchemaType by its GType.
     */
DesktopAgnosticConfigSchemaType* desktop_agnostic_config_schema_find_type (GType type) {
	DesktopAgnosticConfigSchemaType* result = NULL;
	gconstpointer _tmp0_ = NULL;
	_tmp0_ = g_hash_table_lookup (desktop_agnostic_config_schema_type_registry, GINT_TO_POINTER (type));
	result = (DesktopAgnosticConfigSchemaType*) _tmp0_;
	return result;
}


/**
     * Looks for a registered SchemaType by its declared name.
     */
DesktopAgnosticConfigSchemaType* desktop_agnostic_config_schema_find_type_by_name (const gchar* name) {
	DesktopAgnosticConfigSchemaType* result = NULL;
	gconstpointer _tmp0_ = NULL;
	g_return_val_if_fail (name != NULL, NULL);
	_tmp0_ = g_hash_table_lookup (desktop_agnostic_config_schema_name_registry, name);
	result = (DesktopAgnosticConfigSchemaType*) _tmp0_;
	return result;
}


static void desktop_agnostic_config_schema_set_filename (DesktopAgnosticConfigSchema* self, const gchar* value) {
	gchar* basename;
	gboolean _tmp0_;
	gboolean _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_;
	gint _tmp6_;
	gchar* _tmp7_ = NULL;
	gchar* _tmp8_;
	g_return_if_fail (self != NULL);
	basename = NULL;
	_tmp0_ = g_str_has_suffix (value, ".schema-ini");
	if (!_tmp0_) {
		g_critical ("config-schema.vala:166: Schema files MUST have the extension '.schema-" \
"ini'.");
		_g_free0 (basename);
		return;
	}
	_tmp1_ = g_file_test (value, G_FILE_TEST_EXISTS);
	if (!_tmp1_) {
		g_critical ("config-schema.vala:171: The file '%s' could not be found.", value);
		_g_free0 (basename);
		return;
	}
	_tmp2_ = g_strdup (value);
	_tmp3_ = _tmp2_;
	_g_free0 (self->priv->_filename);
	self->priv->_filename = _tmp3_;
	_tmp4_ = g_path_get_basename (value);
	_tmp5_ = _tmp4_;
	_g_free0 (basename);
	basename = _tmp5_;
	_tmp6_ = strlen (basename);
	_tmp7_ = string_substring (basename, (glong) 0, (glong) (_tmp6_ - 11));
	_tmp8_ = _tmp7_;
	desktop_agnostic_config_schema_set_app_name (self, _tmp8_);
	_g_free0 (_tmp8_);
	_g_free0 (basename);
	g_object_notify ((GObject *) self, "filename");
}


const gchar* desktop_agnostic_config_schema_get_app_name (DesktopAgnosticConfigSchema* self) {
	const gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_app_name;
	return result;
}


static void desktop_agnostic_config_schema_set_app_name (DesktopAgnosticConfigSchema* self, const gchar* value) {
	gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup (value);
	_tmp1_ = _tmp0_;
	_g_free0 (self->priv->_app_name);
	self->priv->_app_name = _tmp1_;
	g_object_notify ((GObject *) self, "app-name");
}


static void _g_slist_free__g_free0_ (GSList* self) {
	g_slist_foreach (self, (GFunc) _g_free0_, NULL);
	g_slist_free (self);
}


static void desktop_agnostic_config_schema_class_init (DesktopAgnosticConfigSchemaClass * klass) {
	GHashTable* _tmp0_ = NULL;
	GHashTable* _tmp1_ = NULL;
	GHashTable* _tmp2_ = NULL;
	GList* type_modules = NULL;
	gchar** paths = NULL;
	gint paths_length1 = 0;
	gint _paths_size_ = 0;
	GSList* search_paths = NULL;
	GList* _tmp3_;
	gint _tmp4_;
	gchar** _tmp5_ = NULL;
	gchar** _tmp6_;
	GSList* _tmp7_;
	gchar* _tmp9_ = NULL;
	GValue val = {0};
	gchar* _tmp28_;
	GValue* _tmp29_;
	GError * _inner_error_ = NULL;
	desktop_agnostic_config_schema_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (DesktopAgnosticConfigSchemaPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_desktop_agnostic_config_schema_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_desktop_agnostic_config_schema_set_property;
	G_OBJECT_CLASS (klass)->finalize = desktop_agnostic_config_schema_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_CONFIG_SCHEMA_FILENAME, g_param_spec_string ("filename", "filename", "filename", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DESKTOP_AGNOSTIC_CONFIG_SCHEMA_APP_NAME, g_param_spec_string ("app-name", "Application name", "The name of the application associated with the schema", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	_tmp0_ = g_hash_table_new_full ((GHashFunc) desktop_agnostic_config_gtype_hash, (GEqualFunc) desktop_agnostic_config_gtype_equal, NULL, _g_object_unref0_);
	desktop_agnostic_config_schema_type_registry = _tmp0_;
	_tmp1_ = g_hash_table_new_full (g_str_hash, g_str_equal, _g_free0_, _g_object_unref0_);
	desktop_agnostic_config_schema_name_registry = _tmp1_;
	_tmp2_ = g_hash_table_new_full (g_str_hash, g_str_equal, _g_free0_, __vala_GValue_free0_);
	desktop_agnostic_config_schema_common_metadata_keys = _tmp2_;
	_tmp3_ = NULL;
	__g_list_free__g_free0_0 (type_modules);
	type_modules = _tmp3_;
	desktop_agnostic_module_loader_get_default ();
	desktop_agnostic_config_get_type (&_inner_error_);
	if (_inner_error_ != NULL) {
		goto __catch3_g_error;
	}
	goto __finally3;
	__catch3_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		_g_error_free0 (err);
	}
	__finally3:
	if (_inner_error_ != NULL) {
		__g_slist_free__g_free0_0 (search_paths);
		paths = (_vala_array_free (paths, paths_length1, (GDestroyNotify) g_free), NULL);
		__g_list_free__g_free0_0 (type_modules);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
	}
	_tmp5_ = desktop_agnostic_module_loader_get_search_paths (&_tmp4_);
	_tmp6_ = _tmp5_;
	paths = (_vala_array_free (paths, paths_length1, (GDestroyNotify) g_free), NULL);
	paths_length1 = _tmp4_;
	_paths_size_ = paths_length1;
	paths = _tmp6_;
	_tmp7_ = NULL;
	__g_slist_free__g_free0_0 (search_paths);
	search_paths = _tmp7_;
	{
		gchar** path_collection;
		int path_collection_length1;
		int path_it;
		path_collection = paths;
		path_collection_length1 = paths_length1;
		for (path_it = 0; path_it < paths_length1; path_it = path_it + 1) {
			const gchar* path;
			path = path_collection[path_it];
			{
				if (path != NULL) {
					gchar* _tmp8_;
					_tmp8_ = g_strdup (path);
					search_paths = g_slist_append (search_paths, _tmp8_);
				}
			}
		}
	}
	_tmp9_ = g_get_current_dir ();
	search_paths = g_slist_append (search_paths, _tmp9_);
	{
		GSList* path_collection;
		GSList* path_it;
		path_collection = search_paths;
		for (path_it = path_collection; path_it != NULL; path_it = path_it->next) {
			const gchar* path;
			path = (const gchar*) path_it->data;
			{
				gboolean _tmp10_;
				gchar* _tmp11_ = NULL;
				gchar* module_glob;
				DesktopAgnosticVFSGlob* found_modules = NULL;
				gchar** modules_paths = NULL;
				gint modules_paths_length1 = 0;
				gint _modules_paths_size_ = 0;
				DesktopAgnosticVFSGlob* _tmp12_ = NULL;
				DesktopAgnosticVFSGlob* _tmp13_;
				DesktopAgnosticVFSGlob* _tmp14_;
				gint _tmp15_;
				gchar** _tmp16_ = NULL;
				gchar** _tmp17_;
				_tmp10_ = g_file_test (path, G_FILE_TEST_IS_DIR);
				if (!_tmp10_) {
					continue;
				}
				_tmp11_ = g_build_filename (path, "libda-cfg-type-*", NULL);
				module_glob = _tmp11_;
				_tmp12_ = desktop_agnostic_vfs_glob_execute (module_glob, &_inner_error_);
				_tmp13_ = _tmp12_;
				if (_inner_error_ != NULL) {
					_g_object_unref0 (found_modules);
					if (_inner_error_->domain == DESKTOP_AGNOSTIC_VFS_GLOB_ERROR) {
						goto __catch4_desktop_agnostic_vfs_glob_error;
					}
					_g_object_unref0 (found_modules);
					_g_free0 (module_glob);
					__g_slist_free__g_free0_0 (search_paths);
					paths = (_vala_array_free (paths, paths_length1, (GDestroyNotify) g_free), NULL);
					__g_list_free__g_free0_0 (type_modules);
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
				}
				_tmp14_ = _tmp13_;
				_g_object_unref0 (found_modules);
				found_modules = _tmp14_;
				_tmp16_ = desktop_agnostic_vfs_glob_get_paths (found_modules, &_tmp15_);
				_tmp17_ = _tmp16_;
				modules_paths_length1 = _tmp15_;
				_modules_paths_size_ = modules_paths_length1;
				modules_paths = _tmp17_;
				{
					gchar** module_collection;
					int module_collection_length1;
					int module_it;
					module_collection = modules_paths;
					module_collection_length1 = modules_paths_length1;
					for (module_it = 0; module_it < modules_paths_length1; module_it = module_it + 1) {
						const gchar* module;
						module = module_collection[module_it];
						{
							GList* _tmp18_ = NULL;
							_tmp18_ = g_list_find (type_modules, module);
							if (_tmp18_ == NULL) {
								GType type = 0UL;
								DesktopAgnosticModuleLoader* _tmp19_ = NULL;
								DesktopAgnosticModuleLoader* loader;
								gchar* _tmp20_ = NULL;
								gchar* _tmp21_;
								GType _tmp22_;
								_tmp19_ = desktop_agnostic_module_loader_get_default ();
								loader = _tmp19_;
								_tmp20_ = g_path_get_basename (module);
								_tmp21_ = _tmp20_;
								_tmp22_ = desktop_agnostic_module_loader_load_from_path (loader, _tmp21_, module);
								type = _tmp22_;
								_g_free0 (_tmp21_);
								if (type != G_TYPE_INVALID) {
									GObject* _tmp23_ = NULL;
									GObject* _tmp24_;
									GObject* obj;
									GObject* _tmp25_;
									DesktopAgnosticConfigSchemaType* _tmp26_;
									gchar* _tmp27_;
									_tmp23_ = g_object_new (type, NULL);
									obj = (_tmp24_ = _tmp23_, G_IS_INITIALLY_UNOWNED (_tmp24_) ? g_object_ref_sink (_tmp24_) : _tmp24_);
									_tmp25_ = obj;
									obj = NULL;
									_tmp26_ = DESKTOP_AGNOSTIC_CONFIG_SCHEMA_TYPE (_tmp25_);
									desktop_agnostic_config_schema_register_type (_tmp26_, &_inner_error_);
									_g_object_unref0 (_tmp26_);
									if (_inner_error_ != NULL) {
										_g_object_unref0 (obj);
										if (_inner_error_->domain == DESKTOP_AGNOSTIC_CONFIG_SCHEMA_ERROR) {
											goto __catch5_desktop_agnostic_config_schema_error;
										}
										_g_object_unref0 (obj);
										_g_object_unref0 (found_modules);
										_g_free0 (module_glob);
										__g_slist_free__g_free0_0 (search_paths);
										paths = (_vala_array_free (paths, paths_length1, (GDestroyNotify) g_free), NULL);
										__g_list_free__g_free0_0 (type_modules);
										g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
										g_clear_error (&_inner_error_);
									}
									_tmp27_ = g_strdup (module);
									type_modules = g_list_append (type_modules, _tmp27_);
									_g_object_unref0 (obj);
									goto __finally5;
									__catch5_desktop_agnostic_config_schema_error:
									{
										GError * err;
										err = _inner_error_;
										_inner_error_ = NULL;
										g_warning ("config-schema.vala:120: Schema error: %s", err->message);
										_g_error_free0 (err);
									}
									__finally5:
									if (_inner_error_ != NULL) {
										_g_object_unref0 (found_modules);
										if (_inner_error_->domain == DESKTOP_AGNOSTIC_VFS_GLOB_ERROR) {
											goto __catch4_desktop_agnostic_vfs_glob_error;
										}
										_g_object_unref0 (found_modules);
										_g_free0 (module_glob);
										__g_slist_free__g_free0_0 (search_paths);
										paths = (_vala_array_free (paths, paths_length1, (GDestroyNotify) g_free), NULL);
										__g_list_free__g_free0_0 (type_modules);
										g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
										g_clear_error (&_inner_error_);
									}
								} else {
									g_warning ("config-schema.vala:125: Could not load the config type module: %s", module);
								}
							}
						}
					}
				}
				_g_object_unref0 (found_modules);
				goto __finally4;
				__catch4_desktop_agnostic_vfs_glob_error:
				{
					GError * err;
					err = _inner_error_;
					_inner_error_ = NULL;
					if (!g_error_matches (err, DESKTOP_AGNOSTIC_VFS_GLOB_ERROR, DESKTOP_AGNOSTIC_VFS_GLOB_ERROR_NOMATCH)) {
						g_warning ("config-schema.vala:134: Glob-related error: %s", err->message);
					}
					_g_error_free0 (err);
				}
				__finally4:
				if (_inner_error_ != NULL) {
					_g_free0 (module_glob);
					__g_slist_free__g_free0_0 (search_paths);
					paths = (_vala_array_free (paths, paths_length1, (GDestroyNotify) g_free), NULL);
					__g_list_free__g_free0_0 (type_modules);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
				}
				_g_free0 (module_glob);
			}
		}
	}
	g_value_init (&val, G_TYPE_BOOLEAN);
	g_value_set_boolean (&val, TRUE);
	_tmp28_ = g_strdup ("single_instance");
	_tmp29_ = __g_value_dup0 (&val);
	g_hash_table_insert (desktop_agnostic_config_schema_common_metadata_keys, _tmp28_, _tmp29_);
	desktop_agnostic_config_get_type (&_inner_error_);
	if (_inner_error_ != NULL) {
		goto __catch6_g_error;
	}
	goto __finally6;
	__catch6_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		g_critical ("config-schema.vala:149: Config error: %s", err->message);
		_g_error_free0 (err);
	}
	__finally6:
	if (_inner_error_ != NULL) {
		G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
		__g_slist_free__g_free0_0 (search_paths);
		paths = (_vala_array_free (paths, paths_length1, (GDestroyNotify) g_free), NULL);
		__g_list_free__g_free0_0 (type_modules);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
	}
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
	__g_slist_free__g_free0_0 (search_paths);
	paths = (_vala_array_free (paths, paths_length1, (GDestroyNotify) g_free), NULL);
	__g_list_free__g_free0_0 (type_modules);
}


static void desktop_agnostic_config_schema_instance_init (DesktopAgnosticConfigSchema * self) {
	self->priv = DESKTOP_AGNOSTIC_CONFIG_SCHEMA_GET_PRIVATE (self);
}


static void desktop_agnostic_config_schema_finalize (GObject* obj) {
	DesktopAgnosticConfigSchema * self;
	self = DESKTOP_AGNOSTIC_CONFIG_SCHEMA (obj);
	_g_free0 (self->priv->_filename);
	_g_free0 (self->priv->_app_name);
	_g_hash_table_unref0 (self->priv->keys);
	__g_list_free__g_free0_0 (self->priv->valid_metadata_keys);
	G_OBJECT_CLASS (desktop_agnostic_config_schema_parent_class)->finalize (obj);
}


/**
   * A representation of a configuration schema, comprised of one or more
   * configuration options.
   */
GType desktop_agnostic_config_schema_get_type (void) {
	static volatile gsize desktop_agnostic_config_schema_type_id__volatile = 0;
	if (g_once_init_enter (&desktop_agnostic_config_schema_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DesktopAgnosticConfigSchemaClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) desktop_agnostic_config_schema_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DesktopAgnosticConfigSchema), 0, (GInstanceInitFunc) desktop_agnostic_config_schema_instance_init, NULL };
		GType desktop_agnostic_config_schema_type_id;
		desktop_agnostic_config_schema_type_id = g_type_register_static (G_TYPE_OBJECT, "DesktopAgnosticConfigSchema", &g_define_type_info, 0);
		g_once_init_leave (&desktop_agnostic_config_schema_type_id__volatile, desktop_agnostic_config_schema_type_id);
	}
	return desktop_agnostic_config_schema_type_id__volatile;
}


static void _vala_desktop_agnostic_config_schema_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	DesktopAgnosticConfigSchema * self;
	self = DESKTOP_AGNOSTIC_CONFIG_SCHEMA (object);
	switch (property_id) {
		case DESKTOP_AGNOSTIC_CONFIG_SCHEMA_APP_NAME:
		g_value_set_string (value, desktop_agnostic_config_schema_get_app_name (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_desktop_agnostic_config_schema_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	DesktopAgnosticConfigSchema * self;
	self = DESKTOP_AGNOSTIC_CONFIG_SCHEMA (object);
	switch (property_id) {
		case DESKTOP_AGNOSTIC_CONFIG_SCHEMA_FILENAME:
		desktop_agnostic_config_schema_set_filename (self, g_value_get_string (value));
		break;
		case DESKTOP_AGNOSTIC_CONFIG_SCHEMA_APP_NAME:
		desktop_agnostic_config_schema_set_app_name (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



